#include <gtk/gtk.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "support.h"

gint
check_file_size (gchar *filename)
{
	struct stat buf;

//	printf ("check_file_size: %s", filename);
	choppy (filename, '\0');
	if (g_stat (filename, &buf) == -1)
	{
		return -1;
	}
//	printf ("%ld\n", buf.st_size);
	if (buf.st_size > 10240000)
	{
		return -1;
	}

	return 0;
}

void
get_hw_id (gchar *outstr)
{
	FILE *file;
	gchar filename[512];
	ssize_t read;
        size_t len = 0;
        gchar *line = NULL;

	g_sprintf (filename, "%s/%s/hw_id", g_get_home_dir (), CACHE_DIR);

	file = fopen (filename, "r");
	if (!file)
	{
		return;
	}

	while ((read = getline(&line, &len, file)) != -1) 
	{

		sscanf (line, "%s", outstr);
	}

	g_free (line);
//	outstr[strlen(outstr)-1] = '\0''
}

gint 
check_register ()
{
	FILE *file;
	gchar filename[512];
		
	g_sprintf (filename, "%s/%s/hw_id", g_get_home_dir (), CACHE_DIR);

	file = fopen (filename, "r");

	if (!file)
	{
		return 0;
	}


	return 1;
}

gint
check_cashe ()
{
	FILE *file;
	gchar filename[512];
	
	g_sprintf (filename, "%s/%s/cur_file", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "r");
	if (!file)
	{
//		puts ("tututu");
		return 0;
	}
	
	return 1;
}

void
check_dirs ()
{
	FILE *file, *filecfg;
	gchar filename[512];
	struct stat buf;
	ssize_t read;
	size_t len = 0;
	gchar *line = NULL;

	g_sprintf (filename, "%s/.cache/", g_get_home_dir ());

	if (g_stat (filename, &buf) == -1)
	{
		g_mkdir (filename, 0755);
	}

	g_sprintf (filename, "%s/%s/", g_get_home_dir (), CACHE_DIR);

	if (g_stat (filename, &buf) == -1)
	{
		g_mkdir (filename, 0755);
	}

	g_sprintf (filename, "%s/%s/store", g_get_home_dir (), CACHE_DIR);

	if (g_stat (filename, &buf) == -1)
	{
		g_mkdir (filename, 0755);
	}

	g_sprintf (filename, "%s/%s/screenshots", g_get_home_dir (), CACHE_DIR);

	if (g_stat (filename, &buf) == -1)
	{
		g_mkdir (filename, 0755);
	}

	g_sprintf (filename, "%s/%s/augeas.conf", g_get_home_dir (), CACHE_DIR);

	if (g_stat (filename, &buf) == -1)
	{
		file = fopen ("/var/local/augeas/augeas.conf", "r");
		filecfg = fopen (filename, "w+");

		while ((read = getline(&line, &len, file)) != -1) 
		{
			g_fprintf (filecfg, "%s", line);
		}
		g_free (line);

		fclose (file);
		fclose (filecfg);		
	}

	
}
