#include <netinet/in.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 
#include <stdarg.h>

#include <sys/time.h>
#include <sys/resource.h>
#include <sys/wait.h>

#include "support.h"
#include "check.h"


FILE * fLogOpen;
enum CS_Storage_Debug {
  LOG_NO = 0, // лога нет
  LOG_STDOUT, // в stdout
  LOG_FILE,   // в файл
};

#include "trans.h"

const int flagDebugMode = LOG_STDOUT;

inline void 
WriteLog(char *nameFunction, char *message, ...) 
{
    if (flagDebugMode) {
        va_list listArgs;
        va_start(listArgs, message);
        switch(flagDebugMode) {
            case (LOG_STDOUT): {
                    fprintf(stdout, "%s:", nameFunction);
                    vfprintf(stdout, message, listArgs);
                }
                break;
            case (LOG_FILE): 
                if (fLogOpen) {
                    fprintf(fLogOpen, "%s:", nameFunction);
                    vfprintf(fLogOpen, message, listArgs);
                }
                break;
            default:
                break;
        }
        va_end(listArgs);
    }
}


void 
error (const char *msg)
{
        perror(msg);
        exit(0);
}

#if TRANS
int
send_sec (int sockfd, char *instr, unsigned int size_int)
{
	int len, i = 0;
	unsigned int char_int;

	len = send (sockfd, &size_int, sizeof(size_int), 0);

	while (i != size_int)
	{
		char_int = instr[i];
		send (sockfd, &char_int, sizeof (char_int), 0);
		i++;
	}

	return 0;
}


int
recv_sec (int sockfd, char *outstr)
{
	int recv_size, i = 0, char_int;
	char *buffer;

	recv (sockfd, &recv_size, sizeof (recv_size), 0);
	buffer = (char*)malloc ((recv_size+1)*sizeof(char));

	if (buffer == NULL)
	{
		WriteLog ("recv_sec", "ERROR: Cant allocate memory malloc!\n");
		return -1;
	}
	bzero (buffer, recv_size+1);
	while (i!= recv_size)
	{
		recv (sockfd, &char_int, sizeof (char_int), 0);
		buffer[i] = char_int;
		i++;
	}

	
	buffer [recv_size] = '\0';
	for (i = 0; i < recv_size; i++)
	{
		outstr[i] = buffer[i];
	}

	free (buffer);
	return recv_size;
}
#endif

int 
command_registr (int sockfd, char *first_name, char *second_name, char *email, char *hw_id, char *comment)
{
	char buffer[9];	
	char filename[256];

	send_sec (sockfd, "REGISTR", 7);

	send_sec (sockfd, first_name, strlen (first_name));

	send_sec (sockfd, second_name, strlen (second_name));
	send_sec (sockfd, email, strlen (email));
	send_sec (sockfd, hw_id, strlen (hw_id));
	send_sec (sockfd, comment, strlen (comment));
	
	sprintf (filename, "%s/%s/hwinfo.zip", g_get_home_dir (), CACHE_DIR);
	send_file (sockfd, filename);
	recv_sec (sockfd, buffer);

	if (strcmp (buffer, "FAILED") == 0)
	{
		return 0;
	}

	return 1;
}

#if TRANS
int
recv_file (int sockfd, char *filename)
{
	FILE *f;
	char buffer[BUFSZIE+1];
	int recv_size = 0;

	f = fopen (filename, "w+");
	if (!f)
	{
		exit (1);
	}

	while (1)
	{
		bzero (buffer, BUFSZIE+1);
		recv_size = recv_sec (sockfd, buffer);

		if (strcmp (buffer, "END_FILE") == 0)
		{
			break;
		}
		
		if (strcmp (buffer, "FAILED_FILE") == 0)
		{
			fclose (f);
			return 1;
		}
		fwrite (buffer, 1, recv_size, f);
		fflush (f);
	}
	fclose (f);

	return 0;
}


void
send_file (int sockfd, char *filename)
{
	FILE *f;
        size_t len = 0;
        char line[4097] = "\0";

	f = fopen (filename, "r");

	if (!f)
	{
		WriteLog ("precss_testplans", "ERROR: cant open file\n");
		send_sec (sockfd, "FAILED_FILE", 11);
	}

	while (1) 
	{
		bzero (line, 4096);
		len = fread (line, 1, 4096, f);
		line[len] = '\0';

		send_sec (sockfd, line, len);
		if (len == 0)
		{
			send_sec (sockfd, "END_FILE", 8);
			break;
		}

		if (len < 4096)
		{
			send_sec (sockfd, "END_FILE", 8);
			break;
		}
	}

	fclose (f);
}
#endif

int
command_get_testplans_list (int sockfd, char *filename)
{
	char buffer1[17] = "", hw_id[128] = "";

	send_sec (sockfd, "TESTPLANS", 9);

	get_hw_id (hw_id);
	send_sec (sockfd, hw_id, strlen (hw_id));
	recv_file (sockfd, filename);
	
	bzero (buffer1, 17);
	recv_sec (sockfd, buffer1);

	if (strcmp (buffer1, "END_TESTPLAN_LIST") == 0)
	{
		return 1;
	}
	
	return 0;
}


int
command_get_testplan (int sockfd, char *filename_in, char *filename_out)
{
	char buffer[12];
	int flag;

	send_sec (sockfd, "TESTPLAN_ID", 11);

	flag = 1;

	send_sec (sockfd, filename_in, strlen (filename_in));

	recv_file (sockfd, filename_out);

	recv_sec (sockfd, buffer);
	if (strcmp (buffer, "END_TESTPLAN") == 0)
	{
		return 1;
	}

	return 0;
}


int
command_close_connection (int sockfd)
{
	send_sec (sockfd, "CLOSE_CLIENT", 12);
	return 0;
}


int
command_send_report (int sockfd, char *filename, char *reportname, char *fa_name)
{
	char filename_a[512];
	int i = 0;
	ssize_t read;
	size_t len = 0;
	char *line = NULL;
	FILE *fa;

	send_sec (sockfd, "REPORT_PAID", 11);
	send_sec (sockfd, reportname, strlen (reportname));
	send_file (sockfd, filename);
	fa = fopen (fa_name, "r");

	if (!fa)
	{
	}
	else
	{
		while ((read = getline(&line, &len, fa)) != -1) 
		{
			choppy (line, '\0');
			g_sprintf (filename_a, "%s", line+search_last_slash (line));
			send_sec (sockfd, filename_a, strlen (filename_a));
			send_file (sockfd, line);

		}
		send_sec (sockfd, "END_ATTACHMENTS", 15);
	}
		
	free (line);

	return 0;
}

int
connect_server (char *servername, char *port)
{
        int sockfd, portno, n;
        struct sockaddr_in serv_addr;
        struct hostent *server;

        portno = atoi(port);
        sockfd = socket(AF_INET, SOCK_STREAM, 0);
        if (sockfd < 0) 
	{
                return -1;
	}

        server = gethostbyname(servername);
        if (server == NULL) 
	{
                fprintf(stderr,"ERROR, no such host\n");
                return -1;
        }

 	bzero((char *) &serv_addr, sizeof(serv_addr));
        serv_addr.sin_family = AF_INET;
        bcopy((char *) server->h_addr, 
              (char *)&serv_addr.sin_addr.s_addr,
	               server->h_length);

        serv_addr.sin_port = htons(portno);
        if (connect(sockfd,(struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0) 
	{
		return -1;
	}

	
	send_sec (sockfd, protocol_version, 	strlen (protocol_version));
	send_sec (sockfd, client_version, 	strlen (client_version));

	return sockfd;
}
