#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <string.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <time.h>

#include "support.h"

extern gint cur_file;
extern gchar global_tp_id[64];

void
write_cur_file ()
{
	FILE *file;
	gchar filename[512];

	g_sprintf (filename, "%s/%s/cur_file", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "w+");

	g_fprintf (file, "%d", cur_file);

	fclose (file);
}

void
write_cur_tp_id ()
{
	FILE *file;
	gchar filename[512];

	g_sprintf (filename, "%s/%s/tp_id", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "w+");

	g_fprintf (file, "%s", global_tp_id);

	fclose (file);
}

void
read_cur_file ()
{
	FILE *file;
	gchar filename[512];
	ssize_t read;
        size_t len = 0;
        gchar *line = NULL;


	g_sprintf (filename, "%s/%s/cur_file", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "r");

	while ((read = getline(&line, &len, file)) != -1) 
	{
		sscanf (line,"%d", &cur_file);
	}

	fclose (file);
}


void
read_cur_tp_id ()
{
	FILE *file;
	gchar filename[512];
	ssize_t read;
        size_t len = 0;
        gchar *line = NULL;


	g_sprintf (filename, "%s/%s/tp_id", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "r");

	while ((read = getline(&line, &len, file)) != -1) 
	{
		g_sprintf (global_tp_id, "%s", line);
	}

	fclose (file);
}


void
write_testplan_getted ()
{
	FILE *file;
	gchar filename[512], time_str[128];
	time_t result;

	g_sprintf (filename, "%s/%s/time_testplan_getted", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "w+");

	result = time(NULL);
	strftime (time_str, 128, "%FT%T", localtime(&result));
	g_fprintf (file, "%s\n", time_str);

	fclose (file);
}

void
write_test_started ()
{
	FILE *file;
	gchar filename[512], time_str[128];
	time_t result;

	g_sprintf (filename, "%s/%s/time_test_started", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "w+");

	result = time(NULL);
	strftime (time_str, 128, "%FT%T", localtime(&result));
	g_fprintf (file, "%s\n", time_str);

	fclose (file);
}

void
write_test_finished ()
{
	FILE *file;
	gchar filename[512], time_str[128];
	time_t result;

	g_sprintf (filename, "%s/%s/time_test_finished", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "w+");

	result = time(NULL);
	strftime (time_str, 128, "%FT%T", localtime(&result));
	g_fprintf (file, "%s\n", time_str);

	fclose (file);
}

void
write_test_send_report ()
{
	FILE *file;
	gchar filename[512], time_str[128];
	time_t result;

	g_sprintf (filename, "%s/%s/time_send_report", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "w+");

	result = time(NULL);
	strftime (time_str, 128, "%FT%T", localtime(&result));
	g_fprintf (file, "%s\n", time_str);

	fclose (file);
}

gchar *
read_time (gchar *filename)
{
	FILE *file;
	ssize_t read;
        size_t len = 0;
        gchar *line = NULL;

	file = fopen (filename, "r");
	while ((read = getline(&line, &len, file)) != -1) 
	{
	}

	fclose (file);
	return line;
}


gchar *
get_time_testplan_getted ()
{
	gchar filename[512];
	
	g_sprintf (filename, "%s/%s/time_testplan_getted", g_get_home_dir (), CACHE_DIR);
	return read_time (filename);
}



gchar *
get_time_test_started ()
{
	gchar filename[512];
	
	g_sprintf (filename, "%s/%s/time_test_started", g_get_home_dir (), CACHE_DIR);
	return read_time (filename);
}


gchar *
get_time_test_finished ()
{
	gchar filename[512];
	
	g_sprintf (filename, "%s/%s/time_test_finished", g_get_home_dir (), CACHE_DIR);
	return read_time (filename);
}


gchar *
get_time_report_send ()
{
	gchar filename[512];
	
	g_sprintf (filename, "%s/%s/time_send_report", g_get_home_dir (), CACHE_DIR);
	return read_time (filename);
}

void
write_questions_count ()
{
	FILE *file;
	gchar filename[512];

	g_sprintf (filename, "%s/%s/questions_count", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "w+");

	g_fprintf (file, "%d", questions_count);

	fclose (file);
}



void
read_questions_count ()
{
	FILE *file;
	gchar filename[512];
	ssize_t read;
        size_t len = 0;
        gchar *line = NULL;


	g_sprintf (filename, "%s/%s/questions_count", g_get_home_dir (), CACHE_DIR);
	file = fopen (filename, "r");

	while ((read = getline(&line, &len, file)) != -1) 
	{
		sscanf (line,"%d", &questions_count);
	}

	fclose (file);
}
