#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>
#include <string.h>
#include <time.h>
#include <linux/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>       



#include "support.h"
#include "callbacks.h"
#include "shorthands.h"
#include "state.h"
#include "check.h"
#include "xml_work.h"
#include "attach.h"
#include "pthreads.h"
#include "question.h"

void 
shorthands_init ()
{
        BackButton 	= GetBackButton 	();
        ForwardButton 	= GetForwardButton 	();
        Notebook 	= GetNotebook		();
}


int
main	(int argc, 
	 char *argv[])
{
	GtkListStore *question_list_var;
	gchar text[256];
	GtkWidget *window, *spinner_window;
	GtkBuilder *builder_local;
	gint test;

	questions_count = 0;
	attach_num = 0;
	add_attach_num = 0;
	time_pause = 3;

	if (getuid () != 0)
	{
		g_printf (_("You must to be a root!\n"));
		exit (0);
	}

	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);


#if 0
	gtk_init (&argc, &argv);
	g_thread_init(NULL);
	gdk_threads_init();

	builder = gtk_builder_new ();
        gtk_builder_add_from_file (builder, "/usr/share/augeas_client.glade", NULL);

	cur_file = 13;
	xml_generate_report ();
#endif

#if 1
	gtk_init (&argc, &argv);

	g_thread_init(NULL);
	gdk_threads_init();

	builder = gtk_builder_new ();
        gtk_builder_add_from_file (builder, "/usr/share/augeas_client.glade", NULL);

	shorthands_init ();
	check_dirs ();
	read_config ();
	get_version ();
        g_sprintf (text, _("Screen with delay %d sec\n You can change it in %s/%s/augeas.conf"), time_pause, g_get_home_dir (), CACHE_DIR);
	started	= 0;
	
	if (!check_register ())
	{
		set_state (WELCOME);
		window = GTK_WIDGET (gtk_builder_get_object (builder, "window1"));
		gtk_widget_set_tooltip_text (GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause")), text);
		gtk_builder_connect_signals (builder, NULL);
		gtk_widget_show (window);
	}
	else
	{

		if (!check_cashe ())
		{
			window = GTK_WIDGET (gtk_builder_get_object (builder, "window1"));
			gtk_widget_set_tooltip_text (GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause")), text);
			set_state (GETTESTPLAN);
			gtk_builder_connect_signals (builder, NULL);
			gtk_widget_show (window);
//			builder_local = CreateProgressBar (_("Compair hw_id"), _("Server offline. Try again later."));
			spinner_window = SpinnerWindow (_("Getting testplans. Please wait"));
		    	g_thread_create (pthread_cache, spinner_window, FALSE, NULL);
		}
		else
		{
			read_questions_count ();
			window = GTK_WIDGET (gtk_builder_get_object (builder, "window1"));
			gtk_widget_set_tooltip_text (GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause")), text);
			gtk_builder_connect_signals (builder, NULL);
			gtk_widget_show (window);
			read_cur_file ();
			started = 1;
			read_cur_tp_id ();
			set_state (TEST);
			get_cache_question ();
		}
	}

	gtk_main ();

#endif
	return 0;
}


