#include <gtk/gtk.h>
#include <sys/socket.h>
#include <dirent.h>

#include "state.h"
#include "shorthands.h"
#include "support.h"
#include "attach.h"
#include "question.h"

extern gchar global_tp_name[64];
extern gchar global_tp_id[32];

void
show_error	(gpointer	user_data, 
		gchar		*error_msg)
{
	GtkWidget *widget;

	gtk_window_set_decorated (GTK_WINDOW (gtk_builder_get_object (user_data, "dialog1")), TRUE);

	gtk_window_set_title (GTK_WINDOW (gtk_builder_get_object (user_data, "dialog1")), _("error"));
	widget = GTK_WIDGET (gtk_builder_get_object (user_data, "button_progress_ok"));
	gtk_widget_show (widget);

	widget = GTK_WIDGET (gtk_builder_get_object (user_data, "hbox_progress_error"));
	gtk_widget_show (widget);

	widget = GTK_WIDGET (gtk_builder_get_object (user_data, "progressbar1"));
	gtk_widget_hide (widget);

	gtk_widget_hide (BackButton);
}



gpointer
pthread_register	(gpointer	user_data)
{
	gint server_res = 1;
	GtkWidget *widget;
	gint status, rc;
	gchar name[32] = "\0", fam[32] = "\0",mail[32] = "\0",hw_id[64] = "\0", comment[256] = "\0";
	gchar  filename[256] = "\0", command[128] = "\0";
	gint sockfd;

	server_res = connect_server (server_host, server_port);

	if (server_res != -1)
	{
		g_sprintf (command, "/usr/bin/script_hw_info %s",CACHE_DIR);
		rc = g_spawn_command_line_sync (command, NULL, &status, NULL, NULL);
		rc = wait (&status);

		xml_generators ();

		g_sprintf (command, "/usr/bin/script_hw_info_tar %s",CACHE_DIR);
		rc = g_spawn_command_line_sync (command, NULL, &status, NULL, NULL);
		rc = wait (&status);

		get_hw_id (hw_id);
		read_form (name, fam, mail, comment);

		command_registr (server_res, name, fam, mail, hw_id, comment);
		g_sprintf (filename, "%s/%s/testplans.xml", g_get_home_dir (), CACHE_DIR);
		command_get_testplans_list (server_res, filename);
		command_close_connection (server_res);

		gdk_threads_enter ();
		xml_testplan_read (filename);
		gtk_widget_destroy (user_data);
		set_state (GETTESTPLAN);
		gdk_threads_leave ();
	}
	else
	{
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
		error_dialog (_("Server offline, try again later."), GTK_MESSAGE_ERROR);
		g_sprintf (filename, "%s/%s/hw_id", g_get_home_dir (), CACHE_DIR);
		g_unlink (filename);
		gdk_threads_leave ();
	}
}

gpointer
pthread_get_testplans	(gpointer	user_data)
{
	gint server_res = 1;
	GtkWidget *widget;
	gchar filename[256];	
	
	server_res = connect_server (server_host, server_port);

	if (server_res != -1)
	{
		g_sprintf (filename, "%s/%s/testplan.xml", g_get_home_dir (), CACHE_DIR);
		command_get_testplan (server_res, global_tp_name,  filename);
		command_close_connection (server_res);
		read_xml (filename, user_data);
		
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
	    	write_testplan_getted ();
	    	set_state (TEST);
		get_first_question ();
		gdk_threads_leave ();
	}
	else
	{
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
		error_dialog (_("Server offline, try again later."), GTK_MESSAGE_ERROR);
		gdk_threads_leave ();
	}
}


gboolean 
SpinnerDestroy (gpointer data)
{
	gtk_widget_destroy (data);
	return FALSE;
}

gpointer
pthread_send_report	(gpointer	user_data)
{
	gint server_res = -1, i = 0;
	gint rc, status;
	GtkWidget *widget;
	gchar fa_name[512] = "\0", report_name[512] = "\0", filename[512] = "\0", hw_id[64] = "\0", command[512] = "\0";

	server_res = connect_server (server_host, server_port);
	if (server_res != -1)
	{
		g_sprintf (command, "/usr/bin/script_convert_screenshots %s/%s", g_get_home_dir (), CACHE_DIR);
		rc = g_spawn_command_line_sync (command, NULL, &status, NULL, NULL);
		rc = wait (&status);

		write_test_send_report ();
		g_sprintf (fa_name,"%s/%s/attachs", g_get_home_dir (), CACHE_DIR);
		get_hw_id (hw_id);
		g_sprintf (report_name, "%s_%s_%s",hw_id, global_tp_id, get_time_report_send ());
		g_sprintf (filename,"%s/%s/report.xml", g_get_home_dir (), CACHE_DIR);

		xml_generate_report ();
		command_send_report (server_res, filename, report_name, fa_name);
		command_close_connection (server_res);

		gdk_threads_enter ();
//		gtk_widget_destroy (user_data);
		gtk_widget_hide (BackButton);
		gtk_widget_hide (GTK_WIDGET (gtk_builder_get_object (builder, "button_send")));
		gtk_label_set_text (GTK_LABEL (gtk_builder_get_object (builder, "label_send_pad")), _("Report sending success, now you may relax ;-)\n or start new test!"));
		gtk_widget_show (GTK_WIDGET (gtk_builder_get_object (builder, "button_new_test")));
		gdk_threads_leave ();
		clean_after_send ();
		questions_count = 0;
		started = 100;

		g_idle_add (SpinnerDestroy, user_data);
	}
	else
	{
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
		error_dialog (_("Server offline, try again later."), GTK_MESSAGE_ERROR);
		gdk_threads_leave ();
	}
}


gpointer
pthread_cache	(gpointer	user_data)
{
	gint server_res = 1;
	GtkWidget *widget;
	gint status, rc;
	gchar old_hw_id[128], new_hw_id[128];
	gchar filename[256];

	server_res = connect_server (server_host, server_port);
	g_sprintf (filename, "%s/%s/testplans.xml", g_get_home_dir (), CACHE_DIR);
	
	if (server_res != -1)
	{
		command_get_testplans_list (server_res, filename);

		gdk_threads_enter ();
		xml_testplan_read (filename);
		gtk_widget_destroy (user_data);
		set_state (GETTESTPLAN);
		gdk_threads_leave ();
	}
	else
	{
		gdk_threads_enter ();
		gtk_widget_destroy (user_data);
		error_dialog (_("Server offline, try again later."), GTK_MESSAGE_ERROR);
		gdk_threads_leave ();
	}
}


gpointer
pthread_attach_pause (gpointer	user_data)
{
	GtkWidget *widget;
	time_t result;
	gchar filename[256] = "/0", time_str[128], warning_msg[256] = "\0";
	GdkPixbuf *screenshot;
	GtkWidget *window;

	sleep (time_pause);

	gdk_threads_enter ();
	window = GTK_WIDGET (gtk_builder_get_object (builder, "window1"));
	gtk_window_iconify (GTK_WINDOW (window));
	screenshot = get_screenshot ();
	gtk_window_deiconify (GTK_WINDOW(window));
	result = time(NULL);
	strftime (time_str, 128, "%FT%T", localtime(&result));
	g_sprintf (filename, "%s/%s/screenshots/%d_%s.jpeg", g_get_home_dir (), CACHE_DIR, add_attach_num ++, time_str);
	add_attach (filename);
	if (add_attach_num == (screenshot_num + attachable_num))
	{
		g_sprintf (warning_msg, _("Attach limit is reached"));
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));	
		gtk_widget_set_sensitive (widget, FALSE);	
		gtk_widget_set_tooltip_text (widget, warning_msg);	

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));	
		gtk_widget_set_sensitive (widget, FALSE);		
		gtk_widget_set_tooltip_text (widget, warning_msg);	

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));	
		gtk_widget_set_sensitive (widget, FALSE);		
		gtk_widget_set_tooltip_text (widget, warning_msg);	
	}
	else
	{
		g_sprintf (warning_msg, _("Attach limit is %d used %d"), (screenshot_num + attachable_num), add_attach_num);
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));	

		gtk_widget_set_tooltip_text (widget, warning_msg);	
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));	

		gtk_widget_set_tooltip_text (widget, warning_msg);	
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));	

		gtk_widget_set_tooltip_text (widget, warning_msg);	
	}

	gdk_pixbuf_save (screenshot, filename, "jpeg", NULL,  "quality", "100", NULL);	
	gtk_widget_destroy (user_data);
	gdk_threads_leave ();
}


