#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <string.h>
#include <glib.h>
#include <glib/gprintf.h>

#include "shorthands.h"
#include "curfiletime.h"
#include "attach.h"
#include "question.h"
#include "support.h"

gchar q_id[64] = "\0";
gchar q_name[128] = "\0";
gchar q_article[32] = "\0";


void
get_radio_button (gchar *answer)
{
	GtkWidget *widget;

	if (!g_strcmp0 (answer, "yes"))
	{
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton1"));
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton2"));
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
		
		gtk_widget_set_sensitive (ForwardButton, TRUE);
	}

	if (!g_strcmp0 (answer, "no"))
	{
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton1"));
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton2"));
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
	}
}


void
set_default_form ()
{
	GtkWidget *widget;
	GtkTextBuffer *buffer;
	gchar text[48]="\0";

	widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton1"));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);

	widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton2"));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);

	widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton3"));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

	widget = GTK_WIDGET (gtk_builder_get_object (builder, "textview1"));
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (widget));
        gtk_text_buffer_set_text (buffer, "", 0);

	widget = GTK_WIDGET (gtk_builder_get_object (builder, "label_cur_file"));
	g_sprintf (text, _("<b>Cur file %d from %d</b>"), cur_file + 1, questions_count);
	gtk_label_set_markup (GTK_LABEL (widget), text);

//	printf ("%d\n", attachable);
	
	gtk_widget_set_sensitive (ForwardButton, FALSE);


	destroy_attach_widgets ();
}


gint
read_question	(gchar	*id, 
		gchar	*article, 
		gchar	*answer, 
		gchar 	*comment, 
		gchar 	*attach, 
		gint 	file_id)
{
	FILE *file;
	gchar filename[512], warning_msg[128] = "\0";
	ssize_t read;
	size_t len = 0;
	gchar *line = NULL;
	GtkWidget *widget;
	GtkTextBuffer *buffer;

	add_attach_num =0;
	if (-1 == file_id)
	{
		g_sprintf (filename,"%s/%s/store/%d", g_get_home_dir () ,CACHE_DIR, cur_file);
	}
	else
	{
		g_sprintf (filename,"%s/%s/store/%d", g_get_home_dir (), CACHE_DIR, file_id);
	}

	file = fopen (filename, "r");

	if (file == NULL)
	{
		return 0;
	}

	//destroy_attach_widgets ();
	if (file_id == -1)
	{
		set_default_form ();
	}

	while ((read = getline(&line, &len, file)) != -1) 
	{
		if (g_strrstr (line, "[ANSWERED$]: "))
		{
			line[strlen(line)-1]='\0';
			answered = atoi (line+13);
		}

		if (g_strrstr (line, "[ID$]: "))
		{
			line[strlen(line)-1]='\0';
			bzero (q_id, 64);
			g_sprintf (q_id, "%s", line+7);
			if (file_id != -1)
    		    	{
				g_sprintf (id, "%s", line+7);
			}
		}

		if (g_strrstr (line, "[ARTICLE$]: "))
		{
			line[strlen(line)-1]='\0';
			bzero (q_article, 32);
			g_sprintf (q_article, "%s", line+12);
			if (file_id != -1)
    		    	{
				g_sprintf (article, "%s", line+12);
			}
		}

		if (g_strrstr (line, "[NAME$]: "))
		{
			line[strlen(line)-1]='\0';
			bzero (q_name, 128);
			g_sprintf (q_name, "%s", line+9);
		}

		if (g_strrstr (line, "[ATTACHABLE$]: "))
		{
			line[strlen(line)-1]='\0';
			attachable = atoi (line+15);
		}

		if (attachable)
		{
			if (g_strrstr (line, "[ATTACHABLE_NUM$]: "))
			{
				line[strlen(line)-1]='\0';
				attachable_num = atoi (line+19);
			}

			if (g_strrstr (line, "[ATTACHABLE_SIZE$]: "))
			{
				line[strlen(line)-1]='\0';
				attachable_size = atoi (line+20);
			}
		}

		if (g_strrstr (line, "[SCREENSHOT$]: "))
		{
			line[strlen(line)-1]='\0';
			screenshot = atoi (line+15);
		}

		if (screenshot)
		{
			if (g_strrstr (line, "[SCREENSHOT_NUM$]: "))
			{
				line[strlen(line)-1]='\0';
				screenshot_num = atoi (line+19);
			}

			if (g_strrstr (line, "[SCREENSHOT_SIZE$]: "))
			{
				line[strlen(line)-1]='\0';
				screenshot_size = atoi (line+20);
			}
		}

		if (g_strrstr (line, "[CUR_ATTACH$]: "))
		{
			line[strlen(line)-1]='\0';
			add_attach_num = atoi (line+15);
		}

		if (g_strrstr (line, "[DESCR$]: "))
		{
			line[strlen(line)-1]='\0';
			if (file_id == -1)
			{
				widget = GTK_WIDGET (gtk_builder_get_object (builder, "textview2"));
		    		buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (widget));
    		    		gtk_text_buffer_set_text (buffer, line+10, strlen (line) - 10);
    		    	}
		}

		if (g_strrstr (line, "[ANSWER$]: "))
		{
			line[strlen(line)-1]='\0';

			if (file_id != -1)
	    		{
				g_sprintf (answer, "%s", line+11);
			}
			else
			{
				get_radio_button (line+11);
			}
		}

		if (answered)
		{
			if (g_strrstr (line, "[COMMENT$]: "))
			{
				line[strlen(line)-1]='\0';
    		    		if (file_id != -1)
    		    		{
					if (strlen (line) <= 13)
					{
						g_sprintf (comment, "no comment");
					}
					else
					{
						g_sprintf (comment, "%s", line+12);
					}
				}
				else
				{
    					widget = GTK_WIDGET (gtk_builder_get_object (builder, "textview1"));
		    		        buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (widget));
    		    			gtk_text_buffer_set_text (buffer, line + 12, strlen (line) - 12);
				}
			}

			if (file_id == -1)
			{	
				if (g_strrstr (line, "[ATTACHMENT$]: "))
				{
					add_attach (line+15);
				}
			}
		}
		bzero (line, strlen (line));
	}

	if (attachable == 1)
	{
		gtk_widget_show (GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any")));
	}
	else
	{
		gtk_widget_hide (GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any")));
	}


	if (add_attach_num == (screenshot_num + attachable_num))
	{
		g_sprintf (warning_msg, _("Attach limit is reached"), (screenshot_num + attachable_num), attach_num);
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach"));	
		gtk_widget_set_sensitive (widget, FALSE);	
		gtk_widget_set_tooltip_text (widget, warning_msg);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_any"));	
		gtk_widget_set_sensitive (widget, FALSE);		
		gtk_widget_set_tooltip_text (widget, warning_msg);

		widget = GTK_WIDGET (gtk_builder_get_object (builder, "button_attach_pause"));	
		gtk_widget_set_sensitive (widget, FALSE);		
		gtk_widget_set_tooltip_text (widget, warning_msg);
	}

        g_free (line);
        fclose (file);

        return 1;
}


void
write_question_answer ()
{

	GtkWidget *widget;
	GtkTextBuffer *buffer;
        GtkTextIter iter_start, iter_end;
	gchar answer[5] = "\0";
	gchar comment[8192];
	FILE *file;
	gchar filename[512];

	g_sprintf (filename,"%s/%s/store/%d", g_get_home_dir (), CACHE_DIR, cur_file);
	file = fopen (filename, "w+");

	widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton1"));
	if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)) )
	{
		g_sprintf (answer, "yes");
	}

	widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton2"));
	if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)) )
	{
		g_sprintf (answer, "no");
	}

//	widget = GTK_WIDGET (gtk_builder_get_object (builder, "radiobutton3"));
//	if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)) )
//	{
//		g_sprintf (answer, "skip");
//	}

	widget = GTK_WIDGET (gtk_builder_get_object (builder, "textview2"));
        buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (widget));
        gtk_text_buffer_get_start_iter (buffer, &iter_start);
        gtk_text_buffer_get_end_iter  (buffer, &iter_end);

	g_fprintf (file, "[ANSWERED$]: %d\n", answered);
	g_fprintf (file, "[ID$]: %s\n", q_id);
	g_fprintf (file, "[ARTICLE$]: %s\n", q_article);
	g_fprintf (file, "[NAME$]: %s\n", q_name);
	g_fprintf (file, "[DESCR$]: %s\n", gtk_text_buffer_get_text (buffer, &iter_start, &iter_end, 0));
	g_fprintf (file, "[ANSWER$]: %s\n", answer);


	g_fprintf (file, "[ATTACHABLE$]: %d\n", attachable);
	g_fprintf (file, "[ATTACHABLE_NUM$]: %d\n", attachable_num);
	g_fprintf (file, "[ATTACHABLE_SIZE$]: %d\n", attachable_size);
	g_fprintf (file, "[SCREENSHOT$]: %d\n", screenshot);
	g_fprintf (file, "[SCREENSHOT_NUM$]: %d\n", screenshot_num);
	g_fprintf (file, "[SCREENSHOT_SIZE$]: %d\n", screenshot_size);

	g_fprintf (file, "[CUR_ATTACH$]: %d\n", add_attach_num);

	if (answered)
	{
		widget = GTK_WIDGET (gtk_builder_get_object (builder, "textview1"));
	        buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (widget));

    		gtk_text_buffer_get_start_iter (buffer, &iter_start);
	        gtk_text_buffer_get_end_iter  (buffer, &iter_end);

	        g_sprintf (comment, "%s", gtk_text_buffer_get_text (buffer, &iter_start, &iter_end, 0));
		choppy (&comment, ' ');
		comment[8191] = '\0';
	        g_fprintf (file, "[COMMENT$]: %s\n", comment);
		read_attach (file);
	}

	fclose (file);
}


void
get_first_question ()
{
	cur_file = 0;
	
	read_question (NULL, NULL, NULL, NULL, NULL, -1);
	write_test_started ();
}


gint 
get_next_question ()
{

	write_question_answer ();

	started = 1;
	cur_file ++;

	if (!read_question (NULL, NULL, NULL, NULL, NULL, -1))
	{
		cur_file --;
		write_cur_file ();
		write_test_finished ();
		return 0;
	}

	write_cur_file ();
	return 1;
}

gint
get_prev_question ()
{
	write_question_answer ();
	cur_file --;

	read_question (NULL, NULL, NULL, NULL, NULL, -1);
	write_cur_file ();

	if (cur_file == 0)
	{
		return TRUE;
	}
	return FALSE;
}

void
get_cache_question ()
{
	read_question (NULL, NULL, NULL, NULL, NULL, -1);
	write_cur_file ();

	if (cur_file == 0)
	{
		gtk_widget_hide (BackButton);
	}
}

gint
get_last_file ()
{
	return cur_file;
}

